## net.sf.saxon.expr
Class LetExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.Assignation
              net.sf.saxon.expr.LetExpression

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, LocationProvider, SaxonLocator, Binding, EvaluableItem, SequenceIterable, TailCallReturner, InstructionInfo, org.xml.sax.Locator

Direct Known Subclasses:
  EagerLetExpression

    public class LetExpression

extends Assignation
implements TailCallReturner

A LetExpression is modelled on the XQuery syntax let $x := expr return expr. This syntax is not available in the surface XPath language, but it is used internally in an optimized expression tree.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Assignation
`action, requiredType, sequence, slotNumber, variableName`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, staticProperties`

Constructor Summary
`LetExpression()` Create a LetExpression

Method Summary
`void` `addReference(VariableReference v)` Register a variable reference that refers to the variable bound in this let expression
`void` `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`int` `computeCardinality()` Determine the static cardinality of the expression
`int` `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`Expression` `copy()` Copy an expression.
`protected ValueRepresentation` `eval(XPathContext context)` Evaluate the variable.
`Item` `evaluateItem(XPathContext context)` Evaluate the expression as a singleton
`void` `evaluatePendingUpdates(XPathContext context, PendingUpdateList pul)` Evaluate an updating expression, adding the results to a Pending Update List.
`void` `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the items returned by the expression, if possible
`int` `getNominalReferenceCount()` Get the (nominal) count of the number of references to this variable
`boolean` `implementsStaticTypeCheck()` Determine whether this expression implements its own method for static type checking
`boolean` `isIndexedVariable()` Test whether the variable bound by this let expression should be indexable
`SequenceIterator` `iterate(XPathContext context)` Iterate over the result of the expression to return a sequence of items
`EventIterator` `iterateEvents(XPathContext context)` Iterate over the result of the expression to return a sequence of events
`int` `markTailFunctionCalls(StructuredQName qName, int arity)` Mark tail function calls
`Expression` `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`void` `process(XPathContext context)` Process this expression as an instruction, writing results to the current outputter
`TailCall` `processLeavingTail(XPathContext context)` ProcessLeavingTail: called to do the real work of this instruction.
`Expression` `promote(PromotionOffer offer)` Promote this expression if possible
`void` `setIndexedVariable()` Indicate that the variable bound by this let expression should be indexable (because it is used in an appropriate filter expression)
`Expression` `staticTypeCheck(SequenceType req, boolean backwardsCompatible, RoleLocator role, ExpressionVisitor visitor)` Static type checking for let expressions is delegated to the expression itself, and is performed on the "action" expression, to allow further delegation to the branches of a conditional
`Expression` `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.Assignation

`addToPathMap, checkForUpdatingSubexpressions, evaluateVariable, extendBindingList, getAction, getLocalSlotNumber, getObjectName, getRequiredSlots, getRequiredType, getSequence, getVariableName, getVariableQName, isAssignable, isGlobal, isUpdatingExpression, iterateSubExpressions, promoteWhereClause, refineTypeInformation, replaceSubExpression, setAction, setRequiredType, setSequence, setSlotNumber, setVariableQName, simplify, suppressValidation`

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, computeDependencies, computeStaticProperties, display, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, explain, findParentOf, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, resetLocalStaticProperties, setContainer, setFiltered, setFlattened, setLocationId, toString, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### LetExpression

    public LetExpression()

  Create a LetExpression

Method Detail

### setIndexedVariable

    public void setIndexedVariable()

  Indicate that the variable bound by this let expression should be indexable (because it is used in an appropriate filter expression)

### isIndexedVariable

    public boolean isIndexedVariable()

  Test whether the variable bound by this let expression should be indexable

  Returns:
    true if the variable should be indexable

### getNominalReferenceCount

    public int getNominalReferenceCount()

  Get the (nominal) count of the number of references to this variable

  Returns:
    zero if there are no references, one if there is a single reference that is not in a loop, some higher number if there are multiple references (or a single reference in a loop), or the special value @link RangeVariable#FILTERED} if there are any references in filter expressions that require searching.

### addReference

    public void addReference(VariableReference v)

  Register a variable reference that refers to the variable bound in this let expression

  Parameters:
    `v` - the variable reference

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### implementsStaticTypeCheck

    public boolean implementsStaticTypeCheck()

  Determine whether this expression implements its own method for static type checking

  Overrides:
    `implementsStaticTypeCheck` in class `Expression`
  Returns:
    true - this expression has a non-trivial implementation of the staticTypeCheck() method

### staticTypeCheck

    public Expression staticTypeCheck(SequenceType req,
                                      boolean backwardsCompatible,
                                      RoleLocator role,
                                      ExpressionVisitor visitor)
                               throws XPathException

  Static type checking for let expressions is delegated to the expression itself, and is performed on the "action" expression, to allow further delegation to the branches of a conditional

  Overrides:
    `staticTypeCheck` in class `Expression`
  Parameters:
    `req` - the required type
    `backwardsCompatible` - true if backwards compatibility mode applies
    `role` - the role of the expression in relation to the required type
    `visitor` - an expression visitor
  Returns:
    the expression after type checking (perhaps augmented with dynamic type checking code)
  Throws:
    `XPathException` - if failures occur, for example if the static type of one branch of the conditional is incompatible with the required type

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Overrides:
    `checkPermittedContents` in class `Expression`
  Parameters:
    `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
    `env` - the static context
    `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
  Throws:
    `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate over the result of the expression to return a sequence of items

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### iterateEvents

    public EventIterator iterateEvents(XPathContext context)
                                throws XPathException

  Iterate over the result of the expression to return a sequence of events

  Overrides:
    `iterateEvents` in class `Expression`
  Parameters:
    `context` - The dynamic evaluation context
  Returns:
    the result of the expression as an iterator over a sequence of PullEvent objects
  Throws:
    `XPathException` - if a dynamic error occurs during expression evaluation

### eval

    protected ValueRepresentation eval(XPathContext context)
                                throws XPathException

  Evaluate the variable.

  Parameters:
    `context` - the dynamic evaluation context
  Returns:
    the result of evaluating the expression that is bound to the variable
  Throws:
    `XPathException`

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the expression as a singleton

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### process

    public void process(XPathContext context)
                 throws XPathException

  Process this expression as an instruction, writing results to the current outputter

  Overrides:
    `process` in class `Expression`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by the expression, if possible

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    one of the values Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known in advance)

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

  Specified by:
    `computeCardinality` in class `Expression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `Expression`
  Returns:
    the special properties, as a bit-significant integer

### markTailFunctionCalls

    public int markTailFunctionCalls(StructuredQName qName,
                                     int arity)

  Mark tail function calls

  Overrides:
    `markTailFunctionCalls` in class `Expression`
  Parameters:
    `qName` - the name of the function
    `arity` - the arity (number of parameters) of the function
  Returns:
    0 if no tail call was found; 1 if a tail call on a different function was found; 2 if a tail recursive call was found and if this call accounts for the whole of the value.

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Promote this expression if possible

  Overrides:
    `promote` in class `Assignation`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  ProcessLeavingTail: called to do the real work of this instruction. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Parameters:
    `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
  Returns:
    null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
  Throws:
    `XPathException`

### evaluatePendingUpdates

    public void evaluatePendingUpdates(XPathContext context,
                                       PendingUpdateList pul)
                                throws XPathException

  Evaluate an updating expression, adding the results to a Pending Update List. The default implementation of this method, which is used for non-updating expressions, throws an UnsupportedOperationException

  Overrides:
    `evaluatePendingUpdates` in class `Expression`
  Parameters:
    `context` - the XPath dynamic evaluation context
    `pul` - the pending update list to which the results should be written
  Throws:
    `XPathException`

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `out` - the expression presenter used to display the structure

Copyright (c) Saxonica Limited. All rights reserved.